install 6.5 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187
  1. #!/bin/bash
  2. # Wifi Hotspot app for YunoHost
  3. # Copyright (C) 2015 Julien Vaubourg <julien@vaubourg.com>
  4. # Contribute at https://github.com/jvaubourg/hotspot_ynh
  5. #
  6. # This program is free software: you can redistribute it and/or modify
  7. # it under the terms of the GNU Affero General Public License as published by
  8. # the Free Software Foundation, either version 3 of the License, or
  9. # (at your option) any later version.
  10. #
  11. # This program is distributed in the hope that it will be useful,
  12. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  13. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  14. # GNU Affero General Public License for more details.
  15. #
  16. # You should have received a copy of the GNU Affero General Public License
  17. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  18. # Retrieve arguments
  19. domain=${1}
  20. url_path=${2}
  21. wifi_ssid=${3}
  22. wifi_passphrase=${4}
  23. ##
  24. ## These arguments are optional but YunoHost is not yet able to handle them with the web installer
  25. ## See manifest.json.options
  26. ##
  27. #
  28. #ip6_net=${5}
  29. # Check arguments
  30. if [ -z "${wifi_ssid}" -o -z "${wifi_passphrase}" ]; then
  31. echo "ERROR: Your Wifi Hotspot needs a name and a password" >&2
  32. exit 1
  33. fi
  34. wifi_passphrase_length="$(echo -n "${wifi_passphrase}" | wc -c)"
  35. if [ "${wifi_passphrase_length}" -lt 8 -o "${wifi_passphrase_length}" -gt 63 ]; then
  36. echo "ERROR: Your password must from 8 to 63 characters (WPA2 passphrase)" >&2
  37. exit 1
  38. fi
  39. echo "${wifi_passphrase}" | grep -qP '[^[:print:]]'
  40. if [ $? -eq 0 ]; then
  41. echo "ERROR: Only printable ASCII characters are permitted in your password (WPA2 passphrase)" >&2
  42. exit 1
  43. fi
  44. # Check domain/path availability
  45. sudo yunohost app checkurl ${domain}${url_path} -a hotspot
  46. if [ ! $? -eq 0 ]; then
  47. exit 1
  48. fi
  49. # Install packages
  50. packages='php5-fpm sipcalc hostapd iptables wireless-tools'
  51. sudo apt-get --assume-yes --force-yes install ${packages}
  52. if [ $? -ne 0 ]; then
  53. sudo apt-get update
  54. sudo apt-get --assume-yes --force-yes install ${packages}
  55. fi
  56. # Compute extra arguments
  57. if [ -z "${ip6_net}" ]; then
  58. ip6_net=none
  59. ip6_addr=none
  60. #else
  61. # ip6_net=$(bash ../conf/ipv6_expanded "${ip6_net}")
  62. #
  63. # if [ -z "${ip6_net}" ]; then
  64. # echo "ERROR: The IPv6 Delegated Prefix format looks bad" >&2
  65. # exit 1
  66. # fi
  67. #
  68. # ip6_addr="$(echo "${ip6_net}" | cut -d: -f1-7):42"
  69. # ip6_net=$(bash ../conf/ipv6_compressed "${ip6_net}")
  70. # ip6_addr=$(bash ../conf/ipv6_compressed "${ip6_addr}")
  71. fi
  72. wifi_device=$(sudo iwconfig 2>&1 | grep 802.11 | head -n1 | awk '{ print $1 }')
  73. wifi_n=0
  74. if [ -z "${wifi_device}" ]; then
  75. echo "ERROR: No wifi interface found" >&2
  76. exit 1
  77. fi
  78. sudo iwconfig "${wifi_device}" | grep -q 'n *ESSID'
  79. if [ $? -eq 0 ]; then
  80. wifi_n=1
  81. fi
  82. # Save arguments
  83. sudo yunohost app setting hotspot wifi_ssid -v "${wifi_ssid}"
  84. sudo yunohost app setting hotspot wifi_passphrase -v "${wifi_passphrase}"
  85. sudo yunohost app setting hotspot wifi_device -v "${wifi_device}"
  86. sudo yunohost app setting hotspot wifi_channel -v 6
  87. sudo yunohost app setting hotspot wifi_n -v "${wifi_n}"
  88. sudo yunohost app setting hotspot ip6_addr -v "${ip6_addr}"
  89. sudo yunohost app setting hotspot ip6_net -v "${ip6_net}"
  90. sudo yunohost app setting hotspot ip6_dns0 -v 2001:913::8
  91. sudo yunohost app setting hotspot ip6_dns1 -v 2001:910:800::12
  92. sudo yunohost app setting hotspot ip4_dns0 -v 80.67.188.188
  93. sudo yunohost app setting hotspot ip4_dns1 -v 80.67.169.12
  94. sudo yunohost app setting hotspot ip4_nat_prefix -v 10.0.242
  95. sudo yunohost app setting hotspot vpnclient -v no
  96. # Install IPv6 scripts
  97. sudo install -o root -g root -m 0755 ../conf/ipv6_expanded /usr/local/bin/
  98. sudo install -o root -g root -m 0755 ../conf/ipv6_compressed /usr/local/bin/
  99. # Copy confs
  100. sudo mkdir -pm 0755 /etc/dnsmasq.d.tpl/
  101. sudo chown root: /etc/dnsmasq.d.tpl/
  102. sudo install -b -o root -g root -m 0644 ../conf/hostapd.conf.tpl /etc/hostapd/
  103. sudo install -b -o root -g root -m 0644 ../conf/dnsmasq_dhcpdv6.conf.tpl /etc/dnsmasq.d.tpl/dhcpdv6.conf.tpl
  104. sudo install -b -o root -g root -m 0644 ../conf/dnsmasq_dhcpdv4.conf.tpl /etc/dnsmasq.d.tpl/dhcpdv4.conf.tpl
  105. sudo install -b -o root -g root -m 0644 ../conf/nginx_wifiadmin.conf "/etc/nginx/conf.d/${domain}.d/wifiadmin.conf"
  106. sudo install -b -o root -g root -m 0644 ../conf/phpfpm_wifiadmin.conf /etc/php5/fpm/pool.d/wifiadmin.conf
  107. # Copy web sources
  108. sudo mkdir -pm 0755 /var/www/wifiadmin/
  109. sudo cp -a ../sources/* /var/www/wifiadmin/
  110. sudo chown -R root: /var/www/wifiadmin/
  111. sudo chmod -R 0644 /var/www/wifiadmin/*
  112. sudo find /var/www/wifiadmin/ -type d -exec chmod +x {} \;
  113. # Fix confs
  114. ## hostapd
  115. sudo sed 's|^DAEMON_CONF=$|&/etc/hostapd/hostapd.conf|' -i /etc/init.d/hostapd
  116. ## nginx
  117. sudo sed "s|<TPL:NGINX_LOCATION>|${url_path}|g" -i "/etc/nginx/conf.d/${domain}.d/wifiadmin.conf"
  118. sudo sed 's|<TPL:NGINX_REALPATH>|/var/www/wifiadmin/|g' -i "/etc/nginx/conf.d/${domain}.d/wifiadmin.conf"
  119. sudo sed 's|<TPL:PHP_NAME>|wifiadmin|g' -i "/etc/nginx/conf.d/${domain}.d/wifiadmin.conf"
  120. ## php-fpm
  121. sudo sed 's|<TPL:PHP_NAME>|wifiadmin|g' -i /etc/php5/fpm/pool.d/wifiadmin.conf
  122. sudo sed 's|<TPL:PHP_USER>|admin|g' -i /etc/php5/fpm/pool.d/wifiadmin.conf
  123. sudo sed 's|<TPL:PHP_GROUP>|admins|g' -i /etc/php5/fpm/pool.d/wifiadmin.conf
  124. sudo sed 's|<TPL:NGINX_REALPATH>|/var/www/wifiadmin/|g' -i /etc/php5/fpm/pool.d/wifiadmin.conf
  125. sudo sed 's|^;\?\s*max_execution_time.\+|max_execution_time = 600|' -i /etc/php5/fpm/php.ini
  126. # Fix sources
  127. sudo sed "s|<TPL:NGINX_LOCATION>|${url_path}|g" -i /var/www/wifiadmin/config.php
  128. # Copy init script
  129. sudo install -o root -g root -m 0755 ../conf/init_ynh-hotspot /etc/init.d/ynh-hotspot
  130. # Update firewall for DHCP
  131. sudo yunohost firewall allow --no-upnp --ipv6 UDP 547
  132. sudo yunohost firewall allow --no-upnp UDP 67
  133. # Set default inits
  134. # The boot order of these services are important, so they are disabled by default
  135. # and the ynh-hotspot service handles them.
  136. # All services are registred by yunohost in order to prevent conflicts after the uninstall.
  137. sudo yunohost service add hostapd
  138. sudo yunohost service stop hostapd
  139. sudo yunohost service disable hostapd
  140. sudo yunohost service add php5-fpm
  141. sudo yunohost service enable php5-fpm
  142. sudo service nginx reload
  143. # Remove IPv6 address set if there is a VPN installed
  144. if [ "${ip6_addr}" != none ]; then
  145. sudo ip -6 address show dev tun0 2> /dev/null | grep -q "${ip6_addr}/"
  146. if [ "$?" -eq 0 ]; then
  147. sudo ip address delete "${ip6_addr}/128" dev tun0 &> /dev/null
  148. fi
  149. fi
  150. sudo yunohost service add ynh-hotspot
  151. sudo yunohost service enable ynh-hotspot
  152. sudo service ynh-hotspot start
  153. # Update SSO for wifiadmin
  154. sudo yunohost app ssowatconf
  155. exit 0